<?php 
/************************************************
 Sphider-plus version 1.6 configuration file.

 > > >  DO NOT EDIT THIS FILE. < < < 

Any changes must be done by Admin settings. 
*************************************************/


/*********************** 
General settings 
***********************/

// Sphider-plus version 
$plus_nr = '1.6';

// Original Sphider version 
$version_nr = '1.3.4';

//Standard charset of your location (e.g. ISO-8859-1)
$home_charset = 'ISO-8859-1';

//Administrators email address (logs and info mails can be sent there)
$admin_email = 'admin@localhost';

//Dispatcher email address (info mails will be transmitted from this account)
$dispatch_email = 'postmaster@abc.de';

//Address to localhost document root 
$local = 'http://localhost/publizieren/';

// Sort Sites table in Admin section in alphabetic order
$sites_alpha = 1;

// Free resources when indexing large amount of URLs 
$clear = 0;

// Temporary directory, this should be readable and writable
$tmp_dir = 'tmp';


/*********************** 
Logging settings 
***********************/

//  Enable real-time output of logging data 
$real_log = 1;

//  Interval for real-time Log file update [seconds]
$refresh = 3;

//  Interval until next click will be accepted to increase popularity of a link [seconds]
$click_wait = 30;

// Should log files be kept
$keep_log = 1;

//Log directory, this should be readable and writable
$log_dir = 'log';

// Log format
$log_format = 'html';

// Print spidering results to standard out
$print_results = 1;

//  Send log file to email 
$email_log = 0;


/*********************** 
Spider settings 
***********************/

// Convert Site content into utf-8 charset'
$utf8   = 1;

// Separate between upper- and lower-case queries
$case_sensitive   = 0;

// Sitemap directory, this should be readable and writable 
$smap_dir = 'sitemaps';

// Max. links to be followed per site 
$max_links = '9999';

// Min words per page required for indexing 
$min_words_per_page = 5;

// Words shorter than this will not be indexed
$min_word_length = 3;

// Keyword weight depending on the number of times it appears in a page is capped at this value
$word_upper_bound = 100;

// If available follow 'sitemap.xml'
$follow_sitemap		= 1;

// Index numbers as well
$index_numbers = 1;

// if this value is set to 1, word in domain name and url path are also indexed,// so that for example the index of www.php.net returns a positive answer to query 'php' even 	// if the word is not included in the page itself.
$index_host = 1;


// Whether to index keywords in a meta tag 
$index_meta_keywords = 0;

// Index PDF files
$index_pdf = 1;

// Index DOC files
$index_doc = 1;

// Index RTF files
$index_rtf = 1;

// Index XLS files
$index_xls = 1;

// Index PPT files
$index_ppt = 1;

//Path to PDF converter
$pdftotext_path = '..\\converter\\pdftotext.exe';

//Path to DOC converter
$catdoc_path = '..\\converter\\catdoc.exe';

//Path to XLS converter
$xls2csv_path = '..\\converter\\xls2csv.exe';

//Path to PPT converter
$catppt_path = '..\\converter\\catppt.exe';

// User agent string 
$user_agent = 'Sphider';

// Minimal delay between page downloads 
$min_delay = 0;

// Use word stemming (e.g. find sites containing runs and running when searching for run) 
$stem_words = 0;

// Strip session ids (PHPSESSID, JSESSIONID, ASPSESSIONID, sid) 
$strip_sessids = 1;

// Enable link-check instead of reindex 
$link_check = 0;

// Enable index and re-index for pages with duplicate content 
$dup_content = 1;


/*********************** 
Search settings 
***********************/

//Language of the search page 
$language = 'en';

//Auto detect client language
$auto_lng = '1';

// Template design/Directory in templates dir
$template = 'Sphider-plus';

// Title for Result Page
$mytitle = 'Sphider-plus';

//Type of highlighting for found keywords 
$mark = 'markblue';

// Default for number of results per page
$results_per_page = 20;

// Can speed up searches on large database (should be 0)
$bound_search_result = 0;

// The length of the description string queried when displaying search results. // If set to 0 (default), makes a query for the whole page text, // otherwise queries this many bytes. Can significantly speed up searching on very slow machines 
$length_of_link_desc = 0;

// Number of links shown to next pages
$links_to_next = 9;

// Show meta description in results page if it exists, otherwise show an extract from the page text.
$show_meta_description = 0;

// Show warning message if search string was found only in title or url.
$show_warning = 1;

// Advanced query form, shows and/or buttons
$advanced_search = 1;

// Query scores are not shown if set to 0
$show_query_scores = 1;	

// Query hits are shown if set to 1
$query_hits= 0;	



 // Display category list
$show_categories = 1;

// Max length of page title given in results page
$title_length		= 70;

// Max length of URL given in results page
$url_length		= 70;

// Length of page description given in results page
$desc_length = 250;

// Show order of result listing as headline
$show_sort = 1;

// Show 'Most popular searches' at the bottom of result pages
$most_pop = 1;

// Number of rows for 'Most popular searches'
$pop_rows = 5;

// Min. relevance level (%) to be shown at result pages'
$relevance = 0;

// Show 'User may suggest a Url' at the bottom of result pages
$add_url = 1;

// Inform about user suggestion by e-mail
$addurl_info = 1;

// Use Captcha for Addurl-form
$captcha = 1;

// Enable spelling suggestions (Did you mean...)
$did_you_mean_enabled = 1;

// Enable Sphider Suggest 
$suggest_enabled = 1;

// Search for suggestions in query log 
$suggest_history = 0;

// Search for suggestions in keywords 
$suggest_keywords = 1;

// Search for suggestions in phrases 
$suggest_phrases = 1;

// Limit number of suggestions 
$suggest_rows = 20;


/*********************** 
Weights and result order
***********************/

// Relative weight of a word in the title of a webpage
$title_weight = 20;

// Relative weight of a word in the domain name
$domain_weight = 60;

// Relative weight of a word in the path name
$path_weight = 10;

// Relative weight of a word in meta_keywords
$meta_weight = 5;

// Defines multiplier for words in main URLs (domains)
$domain_mul = 5;

// Defines method of chronological order for result listing
$sort_results = 1;

?>